using System;
using System.Drawing;
using System.Collections;
using System.Collections.Specialized;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

using Syncfusion.Windows.Forms.Grid;

namespace DropDown
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		private Syncfusion.Windows.Forms.Grid.GridControl gridControl1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		StringCollection choiceList;
		ArrayList excludeList;

		public Form1()
		{
			InitializeComponent();
			choiceList = new StringCollection();
			excludeList = new ArrayList();
			choiceList.Add("One");
			choiceList.Add("Two");
			choiceList.Add("Three");
			choiceList.Add("Four");
			choiceList.Add("Five");
			choiceList.Add("Six");
			this.gridControl1[2,2].CellType = "ComboBox";
			this.gridControl1[2,2].ChoiceList = choiceList;
			this.gridControl1[2,3].CellType = "ComboBox";
			this.gridControl1[2,3].ChoiceList = choiceList;
			this.gridControl1.CurrentCellShowingDropDown += new Syncfusion.Windows.Forms.Grid.GridCurrentCellShowingDropDownEventHandler(gridControl1_CurrentCellShowingDropDown);

			//Add Members for which to show different color
			excludeList.Add("Four");
			excludeList.Add("Five");
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.gridControl1 = new Syncfusion.Windows.Forms.Grid.GridControl();
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).BeginInit();
			this.SuspendLayout();
			// 
			// gridControl1
			// 
			this.gridControl1.Location = new System.Drawing.Point(32, 48);
			this.gridControl1.Name = "gridControl1";
			this.gridControl1.Size = new System.Drawing.Size(384, 288);
			this.gridControl1.TabIndex = 0;
			this.gridControl1.Text = "gridControl1";
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(488, 413);
			this.Controls.Add(this.gridControl1);
			this.Name = "Form1";
			this.Text = "Form1";
			((System.ComponentModel.ISupportInitialize)(this.gridControl1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void gridControl1_CurrentCellShowingDropDown(object sender, Syncfusion.Windows.Forms.Grid.GridCurrentCellShowingDropDownEventArgs e)
		{
			GridControl gridControl = sender as GridControl;
			GridCurrentCell cc = gridControl.CurrentCell;
			GridComboBoxCellRenderer cr = cc.Renderer as GridComboBoxCellRenderer;
			if( cc.RowIndex == 2 && cc.ColIndex == 2 )
			{
				cr.ListBoxPart.DrawMode = DrawMode.OwnerDrawVariable;
				cr.ListBoxPart.DrawItem -= new DrawItemEventHandler(ListBoxPart_DrawItem);
				cr.ListBoxPart.DrawItem += new DrawItemEventHandler(ListBoxPart_DrawItem);
			}
			else
				cr.ListBoxPart.DrawMode = DrawMode.Normal;
		}

		//Declare the SavedIndex as the Class Member.....
		int savedIndex = -1;
		private void ListBoxPart_DrawItem(object sender, DrawItemEventArgs e)
		{
		
			//Declare the SavedIndex as the Class Member.....
			//int savedIndex = -1;
			ListBox list = sender as ListBox;
			StringFormat format = new StringFormat();
			format.LineAlignment = StringAlignment.Center;
			format.Alignment = StringAlignment.Center;

			RectangleF rect = new RectangleF(e.Bounds.X, e.Bounds.Y, e.Bounds.Width, e.Bounds.Height);

			if( excludeList.Contains(list.Items[e.Index].ToString()) )
			{
				e.Graphics.FillRectangle(Brushes.LightGray, e.Bounds);
				e.Graphics.DrawString(list.Items[e.Index].ToString(), list.Font, new SolidBrush(list.ForeColor), rect, format);
			}
																															 
			else
			{
				if (list.SelectedIndex == e.Index )
				{
					if(savedIndex != -1 && savedIndex != list.SelectedIndex )
						list.Invalidate(list.GetItemRectangle(savedIndex));
					savedIndex = list.SelectedIndex;
					e.Graphics.FillRectangle(Brushes.MidnightBlue, e.Bounds);
					e.Graphics.DrawString(list.Items[e.Index].ToString(), list.Font, new SolidBrush(list.BackColor), rect, format);
				}
				else
					e.Graphics.DrawString(list.Items[e.Index].ToString(), list.Font, new SolidBrush(list.ForeColor), rect, format);
			}
		}
	}
}
